#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <unistd.h>

#include "memlib.h"
#include "malloc.h"

team_t team = {
    /* Team name to be displayed on webpage */
    "<font color=red><b>fix memory leak, performance goes down</b></font>",
    /* First member full name */
    "Andrew Gardner",
    /* First member email address */
    "asg",
    /* Second member full name (leave blank if none) */
    "",
    /* Second member email address (blank if none) */
    ""
};

/* define'd functions and helper jazz... */

/* important pointers and their friends */
#define free_list_root_ptr (*((int*)(dseg_lo)))
#define wilderness_chunk_ptr (*((int*)(dseg_lo+4)))

/* used to make overhead stuff */
#define OFFSET 8

/* --------------------> mm_init <-------------------- */

int mm_init (void) {
  int SYS_PAGE_SIZE;
  int INIT_MEM_SIZE; /* initial memory size request */
  int i,j,length;  /* counters, a temp */
  int* curr;
  int mem_init_length;

  int mem_init_chunks[] = { 1, 4104,
			    2, 8200,
			    1,  16 }; /* wilderness chunk */

  mem_init_length = 6;

  INIT_MEM_SIZE = 0;
  
  SYS_PAGE_SIZE = mem_pagesize();

  /* 
     Find INIT_MEM_SIZE 
  */

  for( i = 0; i < mem_init_length; i += 2 ){
    INIT_MEM_SIZE += ( ( mem_init_chunks[i+1] ) ) * mem_init_chunks[i];
  }
  INIT_MEM_SIZE += OFFSET; /* for housekeeping overhead, alignment */

  /* remember wilderness chunk pointer (should be later, but value here now */
  (int*)wilderness_chunk_ptr = INIT_MEM_SIZE;

  /* make INIT_MEM_SIZE page boundary happy */
  /* INIT_MEM_SIZE = ( (INIT_MEM_SIZE/SYS_PAGE_SIZE) + 1 ) * SYS_PAGE_SIZE; */
  
  /* 
     Make INIT_MEM_SIZE request
  */

  if( !mem_sbrk( INIT_MEM_SIZE ) )
    return 1;

  *(dseg_lo) = 0;

  /* 
     Prepare housekeeping overhead words
  */

  /* make free_list_root_ptr */
  (int*)free_list_root_ptr = (int*)dseg_lo+4;

  /* make all of the ckunkies, setting headers and footers and things */

  curr = (int*)dseg_lo+4;

  for( i=1; i<mem_init_length; i+=2 ){ /* for each chunk size */
    for( j=0; j<mem_init_chunks[i-1]; j+=1 ){ /* make this many chunks */
             
      length = mem_init_chunks[i];
      
      if( i == mem_init_length-1 )
	length = (int)dseg_hi - (int)dseg_lo+4 + OFFSET;
       
      /* first step, write length in header */
      /**((int*)current_ptr) = length;*/
      
      *curr = length;

      /* second step, write length in footer */
      /**((int*)current_ptr+length-4) = length;*/
      
      *(curr+length/4-1) = length;

      /* third step, write forward pointer */
      /**((int*)current_ptr+4) = current_ptr+length; */

      *(curr+1)= (int)curr+length;
      
      if( j != 0 ){
	*(curr+2) = (int)curr-*curr;
      }else{
	if( i != 1 )
	  *(curr+2) = (int)curr - mem_init_chunks[i-2];
	else
	  *(curr+2) = 0;
      }
      
      /* current_ptr += length;*/
      curr += length/4;

    }
  }

  /* modify the wilderness chunk */
  
  curr -= length/4;

  length = (int)dseg_hi - (int)curr;
  *curr = length;
  *(curr+length/4-1) = length;
  *(curr+1)= 0;

  wilderness_chunk_ptr = (int)curr;

  return 0;
}

/* --------------------> mm_malloc <------------------ */

void *mm_malloc( size_t size ) {

  int *curr, *prev_f, *prev, *extra_chunk;
  int lsize;

  /* algorith:
     attempt to find something useful in the free list
     if there isn't anything in the free list, mem_sbrk
     more memory
     */

  curr = (int*)free_list_root_ptr;

  size += 8;

  prev = NULL;

  while( curr != NULL ){
    if( *curr > size ){
      *(curr+2) = (int)prev;
      goto found;
    }
    prev = curr;
    curr = (int*)*(curr+1);
  }
  
  /* couldn't find anything in the free list,
     must mem_sbrk new memory */
  
  lsize = ((size+8)/8) * 8;
  curr = (int*)(dseg_hi+1);
  *curr = lsize;

  if(!mem_sbrk( lsize )){
    return NULL;
  }

  return curr+2;
  
 found:
  
  /* need to remove current node from the free list */
  
  /* first, make previous node point to my next node */
  prev_f = (int*)*(curr+2);
  if( prev_f ){
    prev_f++;
    *prev_f = *(curr+1);
  }else{
    free_list_root_ptr = *(curr+1);
  }
  
  /* next, make next node point back to my previous */

  /* we may need to hurt this chunk */
  
  if( *curr > 3*size ){
    /* 
       now that we've established that this is a dumb 
       malloc to make, give back a chunk of size+8 and
       turn the extra into a new chunk to put on the
       free list
    */
    
    lsize = ((size+8)/8)*8;
    
    extra_chunk = curr+lsize/4;
    *extra_chunk = *curr-lsize;
  
    *curr = lsize;

    *(extra_chunk+1) = free_list_root_ptr;
    
    free_list_root_ptr = (int)extra_chunk;
    
  }
  
  return curr+2;
  
}


/* --------------------> mm_free<--------------------- */

void mm_free( void *ptr ){

  int *chunk;
  
  chunk = (int*)ptr - 2;
  
  *(chunk+1) = free_list_root_ptr;
  
  free_list_root_ptr = (int)chunk;    
  
}
