/* $Id$ */

/*
 *  Papadimitriou Spiros
 *  spapadim+@cs.cmu.edu
 *
 *  CS213 - Lab assignment 3
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <unistd.h>

#include "memlib.h"
#include "malloc.h"

/*
I went through a lot of complex stuff and was pulling out my hair
for a while, then I found that grading post and realized I could get
90% with this simple implementation...

      -The beauty of simplicity is that it works.
           M. Sproules
*/

team_t team = {
    /* Team name to be displayed on webpage */
    "The Godfather",
    /* First member full name */
    "Joe Giuliani",
    /* First member email address */
    "josephg",
    /* Second member full name (leave blank if none) */
    "",
    /* Second member email address (blank if none) */
    ""
};


//set up a couple of macros...
#define page_size (8192L<<4L)
#define word_size 8L

int mm_init (void)
	{
       	if(mem_sbrk((page_size)+1)==NULL)
	  {
	  }
	*((long*)dseg_lo)=page_size/word_size;
	return 0;
	}

void *mm_malloc (size_t size)
	{
	long		num_words,*searcher,leftover_space;
	
	//calculate the number of words it will take to hold the data
	//add 1 word for the header
	if(size%word_size!=0)
		num_words=2;
	else
		num_words=1;
	num_words+=size>>3;
	if(num_words%2==1)
	  num_words++;
		
	//look for space to allocate
	searcher=dseg_lo;
	while(1)
		{
		if(*searcher&1L==1||*searcher<num_words)
			//if this block is being used or is too small, skip to the next
			{			
			searcher+=((*searcher)&-2L);
			}
		else
			//found a good place, so return it
			{
			leftover_space=*searcher-num_words;
			
			//make header, add 1 to signify that the block is being used
			*searcher=num_words+1;
			
			//relable the rest of the empty space
			if(leftover_space>0)
				{
				*(searcher+num_words)=leftover_space;
				}
			//add word_size to skip the header
			return searcher+1;
			}
		if(searcher>=dseg_hi)
		        {
			//the end of the list has been reached and no good
			//places have been found, so expand...
			if(mem_sbrk(page_size)==NULL)
				{
				printf("failed. returning NULL, searcher was at %x\n",(long)searcher);
				return NULL;
				}

		       	*searcher=page_size/word_size; 
			}
		}
	}

void mm_free (void *ptr)
	{
	  //make the 1s bit 0 to signify that its free
	  *(((long*)ptr)-1)&=-2L;
	}

