/* using the double link list of free blocks, using first fit*/

/* $Id$ */

/*
 *  Papadimitriou Spiros
 *  spapadim+@cs.cmu.edu
 *
 *  CS213 - Lab assignment 3
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <unistd.h>

#include "memlib.h"
#include "malloc.h"

team_t team = {
    /* Team name to be displayed on webpage */
    "Romans",
    /* First member full name */
    "Roman Kurin",
    /* First member email address */
    "rkurin",
    /* Second member full name (leave blank if none) */
    "Anastasiya Koroleva",
    /* Second member email address (blank if none) */
    "ak2"
};

long* findFree (long* begList, size_t size)
{
  long increase = 0;
  long beginSize = 0;
  if (begList==NULL) 
    {
      increase = ((size+mem_pagesize()-1)/mem_pagesize())*mem_pagesize();
      beginSize = (*(*(long **)dseg_lo)) & -2;
      mem_sbrk(increase);
      *(long *)((long)dseg_hi-increase+1)=(increase >> 1) << 1;
      *(long *)((long)dseg_hi-7)=(increase >> 1) << 1;
      *(long **)((long)dseg_hi - 15) = NULL;
      *(long **)((long)((*(long **)dseg_lo))+beginSize-16) = (long) dseg_hi - increase+1;
      *(long **)((long)dseg_hi - increase + 1 +8) = dseg_lo;  
      *(long **)dseg_lo = (long)dseg_hi - increase+1;
      return (*(long **)dseg_lo);
    }
  else 
    if (((*begList) & -2)>=(size + 32)){/*printf("else if\n");*/ return begList;}
    else{/*printf("find_free_ifcaluse\n");*/ 
    return findFree(*(long **)(begList + 8), size);}
}

int mm_init (void)
{
 if ( mem_sbrk(3*mem_pagesize()) !=NULL)
   {
  *(long **)dseg_lo = (long)dseg_lo + 8;
  //    printf("test_init\n");
  *(long *)(dseg_lo+8) = ((3*mem_pagesize()-8)>>1)<<1;
  *(long **)(dseg_lo+16) = NULL;
  *(long *)(dseg_hi-7) = ((3*mem_pagesize()-8)>>1)<<1;
  *(long **)(dseg_hi-15) = NULL;
  return 0;
   }
else
    return -1;
}

void *mm_malloc (size_t size)
{
 
  long* free = findFree(*(long **)dseg_lo, size+32);
  long* prFree = NULL;
  long oldsize = *free & -2;
  long newsize = (((long)free + size + 32 + 1 + 8-1) / 8)*8 - (long)free;
 newsize = (newsize >> 1) << 1;
 //  printf ( "Entered malloc\n");
  * (long *)free = newsize | 1;
  * (long *)((long)free+newsize-8) = newsize | 1;
  *(long *)((long)free+newsize) = ((oldsize - newsize) >> 1) << 1;
  *(long *)((long)free+oldsize-8)= ((oldsize - newsize) >> 1) << 1;
  *(long **)((long)free+newsize+8) = *(long **)((long)free + 8);

  prFree = (long) free + oldsize - 16;
  if (*(long **)prFree==NULL) 
    *(long**)dseg_lo = (long *)((long)free + newsize);
  else
    *(long **)(prFree+8) =(long *)((long)free + newsize) ;
  // printf("possible error\n");
  return (void *) free ;
}

void mm_free (void *pointr)
{
  long* ptr = (long*) pointr;
  long pOcup = *(ptr - 8) & 1;
  long size = *ptr & -2;
  long psize= *(ptr - 8) & -2;
  long nsize = *(ptr+size) & -2;
  long nOcup = *(ptr+size) & 1;
  // printf ("enter FREEEEEEEEEEEE\n");
  if (!pOcup && !nOcup && ((long)ptr-8)!=(long)dseg_lo && ((long)ptr+size)!=(long)dseg_hi) 
    {//printf("mm_free_if1\n");
      *(ptr-psize) = ((psize + size + nsize)>>1)<<1;
      *(ptr+size+nsize-8) = ((psize + size + nsize)>>1)<<1;
      *(long **)(ptr-psize+8) = *(long *)(ptr + 8);
      *(long **)(ptr + size + nsize-16) = *(long *)(ptr+size-16);
    }
  else 
    if (!pOcup && ((long)ptr-8)!=(long)dseg_lo)
      {
	//printf("mm_freeif2\n");
	*(ptr+size-8) = ((psize + size)>> 1) << 1;
	*(ptr-psize)= ((psize + size) >> 1) << 1;
	*(long **) (ptr+size-16)= *(long *)(ptr - 16);
      }
  else if (!nOcup && ((long)ptr+size)!=(long)dseg_hi)
    { //printf("mm_free_if3\n");
      *ptr = ((size+nsize)>>1)<<1;
      *(ptr+size+nsize-8) = ((size+nsize)>>1)<<1;
      *(long **)(ptr+8) = *(long *)(ptr+size+8); 
    }
  else
    {// printf("mm_free_else\n");
     *ptr = (*ptr >> 1) << 1;
     *(ptr+size-8)= (*(ptr+size) >> 1) << 1;
     *(long **) (ptr+8) = dseg_lo;
     *(long **)(dseg_lo) = ptr;
     *(long **)(ptr+size-16)=NULL;
     
    }
}

