/* $Id$ */

/*
 *  Papadimitriou Spiros
 *  spapadim+@cs.cmu.edu
 *
 *  CS213 - Lab assignment 3
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <unistd.h>

#include "memlib.h"
#include "malloc.h"

team_t team = {
    /* Team name to be displayed on webpage */
    "<a href='http://www.siggraph.org'>I am a bad person</a>",
    /* First member full name */
    "Christine M Chun",
    /* First member email address */
    "keil",
    /* Second member full name (leave blank if none) */
    "Matthew C Kurtz",
    /* Second member email address (blank if none) */
    "mk7q"
};


int mm_init (void)
{
   
    int *heap = mem_sbrk(8192);


    *(long *)(dseg_lo) =  8168L;

    *((long*)dseg_lo+1) = NULL;
    
    *((long *)dseg_lo + 2) = NULL;

    if (heap == NULL)
      { return -1; }
    return 0;
}

void *mm_malloc (size_t size)
{

 
    long sizea = (long)(size/8);
    long curr_block_header = *(long *)(dseg_lo);
    long *curr_block_add = (long *)dseg_lo;
    long *currpoint = (long *)*((long *)dseg_lo + 8);


    if (size % 8) {
      sizea+=8;
    }


  while (currpoint != NULL)
    {

      if (((curr_block_header & 1L) == 0) && (curr_block_header >= size + 48))
	{

	  *(long *)(curr_block_add + sizea + 3) = curr_block_header - size - 24;
	  *(long *)(curr_block_add + sizea + 4) = (long) currpoint;
	  *(long *)(curr_block_add + sizea + 5) = (long) curr_block_add;
	  *(long *)(curr_block_add) = sizea + 1;
	  *(long *)(curr_block_add + 1) = (long) currpoint + size + 24;

	  *(long *)(currpoint + 2) = (long) curr_block_add + size + 24;

	  return (void *)(curr_block_add + 3);
	}
      else {
	curr_block_add = (void *)((long) curr_block_add + curr_block_header + 24);
	curr_block_header = *(curr_block_add);
	currpoint = (void *)((long) curr_block_add + 1);
	pause();
      }
    }
  if ((curr_block_header & 1) == 1) 
    {
      long newspace = 1024 * ((size + 24) / 1024L) + 1024L;
      long *heap = mem_sbrk(newspace);
     
   


     *(long *)(heap) = size + 1;
     *(long *)(heap+1) = (long)   heap + size + 24;
     *(long *)(heap+2) = (long) curr_block_add;
     *(long *)(curr_block_add + 2) = (long) heap;


     *(long *)(heap + sizea + 3) = newspace - size;
     *(long *)(heap + sizea + 4) = NULL;
     *(long *)(heap + sizea + 5) = (long) heap;
     return (void *)(heap + 3);
    }
  else {
    if ((size + 48) < curr_block_header) 
      {
	

	*(long *)(curr_block_add + sizea + 3) = curr_block_header - size - 24;
	*(long *)(curr_block_add + sizea + 4) = NULL;
	*(long *)(curr_block_add + sizea + 5) = (long) curr_block_add;

	*(long *)(curr_block_add) = size + 1;
	*(long *)(curr_block_add + 1) = size + 24;

	return (void *)(curr_block_add + 3);
      }
    else 
      {
	long newspace = 1024 * ((size + 24) / 1024L) + 1024L;
	long *heap = mem_sbrk(newspace);

	if (heap == NULL)
	  return heap;
       
	/* new next header, have to change the int to (x - 24) */
	*(long *)(curr_block_add + sizea + 3) = newspace - 24  + curr_block_header - size;
	*(long *)(curr_block_add + sizea + 4) = NULL;
	*(long *)(curr_block_add + sizea + 5) = (long) curr_block_add;
	
	/* this block */
	*(long *)(curr_block_add) = size + 1;
        *(long *)(curr_block_add + 1) = (long) curr_block_add + size + 24;

	return (void *)(curr_block_add + 3);
      }
  }
}
	


void mm_free (void *ptr)
{
  long *ptrcopy;
  long size;
  long *next;
  long *prev;

  ptrcopy = (void *)((long)(ptr - 24));
  next = (long *)*((long *)ptrcopy + 8);
  prev = (long *)*((long *)ptrcopy + 16);

  size = *(ptrcopy) & ~1L;
  *(ptrcopy) = size;


  if (((next) != NULL) && (((*(long *)(next)) & 1L) == 0))
      {
 
      /* change the current header */
         *(long *)(ptrcopy) = *(long *)(ptrcopy) + *(long *)(next);
      *(long *)(ptrcopy + 8) = (long)(*(long *)(next + 1));
      

      /* change the new next's prev pointer */
          if (((*(long *)(next)) + 1) != NULL)
    	*(long *)(next + 2) = (long)(ptrcopy);

      }
     if (((prev) != NULL) && (((*(long *)(prev)) & 1L) == 0))
     {

      /* change the previous header */
       *(long *)(prev) = *(long *)(prev) + *(long *)(ptrcopy);
      *(long *)(prev + 1) = (long)(*(long *)(ptrcopy + 1));


      /* change the new next's prev pointer */
      if ((*(long *)(ptrcopy + 1)) != NULL)
    	*(long *)((*(long *)(ptrcopy + 1)) + 2) = (long)(*(long *)(prev));
     }
}
 






